#version 430 core

layout (points) in;
layout (triangle_strip, max_vertices = 4) out;

// Input variables
in VertexData
{
	vec4 position_vs;		// Position in view space
	vec3 color;
} inData[1];

// Output variables
out VertexData
{
	vec3 color;
	vec2 tex_coord;
} outData;

// Data of the camera
layout (std140, binding = 0) uniform CameraData
{
	mat4 projection;		// Projection matrix
	mat4 projection_inv;	// Inverse of the projection matrix
	mat4 view;				// View matrix
	mat4 view_inv;			// Inverse of the view matrix
	mat3 view_it;			// Inverse of the transpose of the top-left part 3x3 of the view matrix
	vec3 eye_position;		// Position of the eye in world space
};

uniform float particle_size_vs;

//-----------------------------------------------------------------------

const vec2 quad_tex_coords[4] = vec2[4](
	vec2(0.0, 1.0),
	vec2(0.0, 0.0),
	vec2(1.0, 1.0),
	vec2(1.0, 0.0)
);
const vec4 quad_offsets[4] = vec4[4](
	vec4(-0.5, +0.5, 0.0, 0.0),
	vec4(-0.5, -0.5, 0.0, 0.0),
	vec4(+0.5, +0.5, 0.0, 0.0),
	vec4(+0.5, -0.5, 0.0, 0.0)
);

void main()
{
	// Task 4: Compute the color, the texture coordinate, and the final position of each vertex
	//			of the quad. Store them into outData.color, outData.tex_coord, and gl_Position,
	//			respectively. Don't forget the EmitVertex() function. Don't forget to transform
	//			the position with the projection matrix.
	//		Hint: The data from the vertex shader is in inData. Don't forget it is an array. Also,
	//			texture coordinates and offsets of each of the quad vertex is in quad_tex_coords
	//			and quad_offsets arrays, in order they should be emitted.
}
